Option Strict Off
Option Explicit On 

Imports Microsoft.VisualBasic
Imports Syncfusion.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Windows.Forms


Public Class DropDownGridCellRenderer
    Inherits GridDropDownGridCellRenderer
    Private WithEvents dbgrid As GridDataBoundGrid
    'Fields
    'Constructors
    'Methods
    Public Sub New(ByVal grid As GridControlBase, ByVal cellModel As GridCellModelBase)
        MyBase.New(grid, cellModel)
        Me.DisableTextBox = True
        DropDownButton = New GridCellComboBoxButton(Me)
        Me.dbgrid = Nothing

    End Sub
    Protected Overloads Overrides Function CreateInnerControl(ByRef grid As GridControlBase) As Control

        grid = Me.dbgrid
        grid.Dock = DockStyle.Fill
        Return grid

    End Function
    Public Overloads Overrides Sub DropDownContainerShowingDropDown(ByVal sender As Object, ByVal e As CancelEventArgs)

        MyBase.DropDownContainerShowingDropDown(sender, e)

        'fire the event that allows for the formatting of the dropped grid
        dbgrid.BeginInit()
        Dim e1 As QueryFormatGridEventArgs
        e1 = New QueryFormatGridEventArgs(Me.RowIndex, Me.ColIndex, dbgrid)
        CType(Me.Model, DBDropDownGridCellModel).OnQueryFormatGrid(e1)
        ' dbgrid.Model.ColWidths.ResizeToFit(GridRangeInfo.Row(0))
        dbgrid.EndInit()

        'set its height & width based on the parent grid
        Dim width As Integer
        width = ((Me.Grid.Size.Width - Me.Grid.Model.ColWidths(0)) _
                    - SystemInformation.VerticalScrollBarWidth)
        Dim height As Integer
        height = (Math.Max(60, Me.dbgrid.Model.RowHeights.GetTotal(0, Math.Min(6, Me.dbgrid.Model.RowCount))) + SystemInformation.HorizontalScrollBarHeight)
        Me.DropDownContainer.PopupHost.Size = New Size(width, height)

    End Sub
    Protected Overloads Overrides Sub OnInitialize(ByVal rowIndex As Integer, ByVal colIndex As Integer)

        Dim cellModel As DBDropDownGridCellModel
        cellModel = CType(Me.Model, DBDropDownGridCellModel)
        Me.dbgrid = cellModel.EmbeddedGrid
        'fire the event to retrieve the filter string...
        Dim filter As String
        filter = ""
        Dim e As QueryFilterStringEventArgs
        e = New QueryFilterStringEventArgs(rowIndex, colIndex)
        cellModel.OnQueryFilterString(e)
        filter = e.FilterString
        'get the view based on the filter & set it as the datasource
        Dim dt1 As DataTable
        dt1 = CType(cellModel.DataSource, DataTable)
        Dim dv As DataView
        dv = New DataView(dt1, filter, "", DataViewRowState.CurrentRows)
        If dt1.TableName = "Corrections" Then
            dv.AllowNew = True
        Else
            dv.AllowNew = False
        End If
        'dv.AllowEdit = false;
        dv.AllowDelete = False
        'make sure dggrid has a binding context...
        If (Me.dbgrid.BindingContext Is Nothing) Then
            Me.dbgrid.BindingContext = Me.Grid.BindingContext
        End If
        Me.dbgrid.DataSource = dv

    End Sub
End Class

